package Lambda;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;
import java.util.*;
import java.util.function.Predicate;

public class PredicateExample1 {

    private static final Logger logger = LoggerFactory.getLogger(FunctionalInterfaceExample.class);

    public static void main(String[] args) {
        List<User> users = new ArrayList<User>();
        users.add(new User("dev","Harshitha"));
        users.add(new User("dev","yamini"));
        users.add(new User("QA","Anusha"));

        List devs = process(users,(User u)->u.getRole().equals("dev"));
        logger.info(devs.toString());

    }

    public static  List<User> process(List<User> users, Predicate<User> predicate){
        List<User> result = new ArrayList<User>();
        for(User user:users){
            if(predicate.test(user)){
                result.add(user);
            }
        }
        return  result;
    }
}

