package Lambda;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.function.Consumer;
import java.util.function.Supplier;

public class SupplierExample {

    private static final Logger logger = LoggerFactory.getLogger(FunctionalInterfaceExample.class);
    public static void main(String[] args) {

        //example of supplier
        Supplier<String> supplier = () -> {
            logger.info("inside the supplier");
            return  "hello";
        };
        String string = supplier.get();
        logger.info(string);


        //example of consumer
        Consumer<String> consumer = (String s) -> {
           logger.info("Inside the consumer");
            logger.info(s);
        };
        consumer.accept("hello");

        Supplier<String> supplier1 = () -> {
            logger.info("Supplier");
            return "hello";
        };
        String s = supplier1.get();
        logger.info(s);
    }
}
